jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Alex Light | ea1e770 | 2016-07-11 13:39:55 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Nicolas Geoffray | 1c5b6da | 2016-03-16 10:55:57 +0000 | [diff] [blame] | 48 | export USE_JACK="true" |
Alex Light | b55f1ac | 2016-04-12 15:50:55 -0700 | [diff] [blame] | 49 | export SMALI_ARGS="--experimental" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 76 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 77 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 78 | export ANDROID_BUILD_TOP=$oldwd |
| 79 | fi |
| 80 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 81 | # ANDROID_HOST_OUT is not set in a build environment. |
| 82 | if [ -z "$ANDROID_HOST_OUT" ]; then |
| 83 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86 |
| 84 | fi |
| 85 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 86 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 87 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 88 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 89 | fi |
| 90 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 91 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 92 | |
Igor Murashkin | 19e5f83 | 2017-02-07 15:20:54 -0800 | [diff] [blame] | 93 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 94 | if [ -z "$ZIPALIGN" ]; then |
| 95 | if which zipalign >/dev/null; then |
| 96 | ZIPALIGN="zipalign"; |
| 97 | else |
| 98 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 99 | # once it doesn't depend on libandroidfw (b/35246701) |
| 100 | case "$OSTYPE" in |
| 101 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 102 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 103 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 104 | esac |
| 105 | fi |
| 106 | fi |
| 107 | export ZIPALIGN |
| 108 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 109 | info="info.txt" |
| 110 | build="build" |
| 111 | run="run" |
| 112 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 113 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 114 | output="output.txt" |
| 115 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 116 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 117 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 118 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 119 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 120 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 121 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 123 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 124 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 125 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 126 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 127 | dev_mode="no" |
| 128 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 129 | debug_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 130 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 131 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 132 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 133 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 134 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 135 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 136 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 137 | basic_verify="false" |
| 138 | gc_verify="false" |
| 139 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 140 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 141 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 142 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 143 | have_dex2oat="yes" |
| 144 | have_patchoat="yes" |
| 145 | have_image="yes" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 146 | pic_image_suffix="" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 147 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 148 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 149 | bisection_search="no" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 150 | suspend_timeout="500000" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 151 | # By default we will use optimizing. |
| 152 | image_args="" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 153 | image_suffix="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 154 | |
| 155 | while true; do |
| 156 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 157 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 158 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 159 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 160 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 161 | elif [ "x$1" = "x--quiet" ]; then |
| 162 | quiet="yes" |
| 163 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 164 | elif [ "x$1" = "x--use-java-home" ]; then |
| 165 | if [ -n "${JAVA_HOME}" ]; then |
| 166 | export JAVA="${JAVA_HOME}/bin/java" |
| 167 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 168 | else |
| 169 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 170 | usage="yes" |
| 171 | fi |
| 172 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 173 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 174 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 175 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 176 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 177 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 178 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 179 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 180 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 181 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 182 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 183 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 184 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 185 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 186 | testlib="arttest" |
Alex Light | faf90b6 | 2016-08-12 14:43:48 -0700 | [diff] [blame] | 187 | run_args="${run_args} -O" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 188 | shift |
| 189 | elif [ "x$1" = "x--dalvik" ]; then |
| 190 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 191 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 192 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 193 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 194 | have_dex2oat="no" |
| 195 | shift |
| 196 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 197 | have_patchoat="no" |
| 198 | shift |
| 199 | elif [ "x$1" = "x--no-image" ]; then |
| 200 | have_image="no" |
| 201 | shift |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 202 | elif [ "x$1" = "x--npic-image" ]; then |
| 203 | pic_image_suffix="-npic" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 204 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 205 | elif [ "x$1" = "x--multi-image" ]; then |
| 206 | multi_image_suffix="-multi" |
| 207 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 208 | elif [ "x$1" = "x--pic-test" ]; then |
| 209 | run_args="${run_args} --pic-test" |
| 210 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 211 | elif [ "x$1" = "x--relocate" ]; then |
| 212 | relocate="yes" |
| 213 | shift |
| 214 | elif [ "x$1" = "x--no-relocate" ]; then |
| 215 | relocate="no" |
| 216 | shift |
| 217 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 218 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 219 | prebuild_mode="yes" |
| 220 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 221 | elif [ "x$1" = "x--strip-dex" ]; then |
| 222 | run_args="${run_args} --strip-dex" |
| 223 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 224 | elif [ "x$1" = "x--debuggable" ]; then |
| 225 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 226 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 227 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 228 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 229 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 230 | prebuild_mode="no" |
| 231 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 232 | elif [ "x$1" = "x--gcverify" ]; then |
| 233 | basic_verify="true" |
| 234 | gc_verify="true" |
| 235 | shift |
| 236 | elif [ "x$1" = "x--gcstress" ]; then |
| 237 | basic_verify="true" |
| 238 | gc_stress="true" |
| 239 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 240 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 241 | shift |
| 242 | suspend_timeout="$1" |
| 243 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 244 | elif [ "x$1" = "x--image" ]; then |
| 245 | shift |
| 246 | image="$1" |
| 247 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 248 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 249 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 250 | shift |
| 251 | option="$1" |
| 252 | run_args="${run_args} -Xcompiler-option $option" |
| 253 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 254 | elif [ "x$1" = "x--runtime-option" ]; then |
| 255 | shift |
| 256 | option="$1" |
| 257 | run_args="${run_args} --runtime-option $option" |
| 258 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 259 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 260 | shift |
| 261 | gdb_arg="$1" |
| 262 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 263 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 264 | elif [ "x$1" = "x--debug" ]; then |
| 265 | run_args="${run_args} --debug" |
| 266 | shift |
| 267 | elif [ "x$1" = "x--gdb" ]; then |
| 268 | run_args="${run_args} --gdb" |
| 269 | dev_mode="yes" |
| 270 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 271 | elif [ "x$1" = "x--strace" ]; then |
| 272 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 273 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 274 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 275 | elif [ "x$1" = "x--zygote" ]; then |
| 276 | run_args="${run_args} --zygote" |
| 277 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 278 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 279 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 280 | image_suffix="-interpreter" |
| 281 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 282 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 283 | image_args="--jit" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 284 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 285 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 286 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 287 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 288 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 289 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 290 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 291 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 292 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 293 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 294 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 295 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 296 | elif [ "x$1" = "x--no-optimize" ]; then |
| 297 | run_args="${run_args} --no-optimize" |
| 298 | shift |
| 299 | elif [ "x$1" = "x--no-precise" ]; then |
| 300 | run_args="${run_args} --no-precise" |
| 301 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 302 | elif [ "x$1" = "x--invoke-with" ]; then |
| 303 | shift |
| 304 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 305 | if [ "x$what" = "x" ]; then |
| 306 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 307 | usage="yes" |
| 308 | break |
| 309 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 310 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 311 | shift |
| 312 | elif [ "x$1" = "x--dev" ]; then |
| 313 | run_args="${run_args} --dev" |
| 314 | dev_mode="yes" |
| 315 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 316 | elif [ "x$1" = "x--build-only" ]; then |
| 317 | build_only="yes" |
| 318 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 319 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 320 | USE_JACK="false" |
| 321 | shift |
| 322 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 323 | USE_JACK="true" |
| 324 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 325 | elif [ "x$1" = "x--output-path" ]; then |
| 326 | shift |
| 327 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 328 | if [ "x$tmp_dir" = "x" ]; then |
| 329 | echo "$0 missing argument to --output-path" 1>&2 |
| 330 | usage="yes" |
| 331 | break |
| 332 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 333 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 334 | elif [ "x$1" = "x--android-root" ]; then |
| 335 | shift |
| 336 | if [ "x$1" = "x" ]; then |
| 337 | echo "$0 missing argument to --android-root" 1>&2 |
| 338 | usage="yes" |
| 339 | break |
| 340 | fi |
| 341 | android_root="$1" |
| 342 | run_args="${run_args} --android-root $1" |
| 343 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 344 | elif [ "x$1" = "x--update" ]; then |
| 345 | update_mode="yes" |
| 346 | shift |
| 347 | elif [ "x$1" = "x--help" ]; then |
| 348 | usage="yes" |
| 349 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 350 | elif [ "x$1" = "x--64" ]; then |
| 351 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 352 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 353 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 354 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 355 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 356 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 357 | elif [ "x$1" = "x--stream" ]; then |
| 358 | trace_stream="true" |
| 359 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 360 | elif [ "x$1" = "x--always-clean" ]; then |
| 361 | always_clean="yes" |
| 362 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 363 | elif [ "x$1" = "x--never-clean" ]; then |
| 364 | never_clean="yes" |
| 365 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 366 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 367 | run_args="${run_args} --dex2oat-swap" |
| 368 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 369 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 370 | shift |
| 371 | run_args="${run_args} --instruction-set-features $1" |
| 372 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 373 | elif [ "x$1" = "x--bisection-search" ]; then |
| 374 | bisection_search="yes" |
| 375 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 376 | elif [ "x$1" = "x--vdex" ]; then |
| 377 | run_args="${run_args} --vdex" |
| 378 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 379 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 380 | shift |
| 381 | filter=$1 |
| 382 | run_args="${run_args} --vdex-filter $filter" |
| 383 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 384 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 385 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 386 | usage="yes" |
| 387 | break |
| 388 | else |
| 389 | break |
| 390 | fi |
| 391 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 392 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 393 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 394 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 395 | # output (fd 2). |
| 396 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 397 | exec {real_stderr}>&2 |
| 398 | else |
| 399 | # In bash before version 4.1 we need to do a manual search for free file |
| 400 | # descriptors. |
| 401 | FD=3 |
| 402 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 403 | real_stderr=$FD |
| 404 | eval "exec ${real_stderr}>&2" |
| 405 | fi |
| 406 | if [ "$quiet" = "yes" ]; then |
| 407 | # Force the default standard output and error to go to /dev/null so we will |
| 408 | # not print them. |
| 409 | exec 1>/dev/null |
| 410 | exec 2>/dev/null |
| 411 | fi |
| 412 | |
| 413 | function err_echo() { |
| 414 | echo "$@" 1>&${real_stderr} |
| 415 | } |
| 416 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 417 | # tmp_dir may be relative, resolve. |
| 418 | # |
| 419 | # Cannot use realpath, as it does not exist on Mac. |
| 420 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 421 | # Cannot use readlink -m, as it does not exist on Mac. |
| 422 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 423 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 424 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 425 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 426 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 427 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 428 | if [ ! "$runtime" = "jvm" ]; then |
| 429 | run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout" |
| 430 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 431 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 432 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 433 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 434 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 435 | fi |
| 436 | if [ "$gc_verify" = "true" ]; then |
| 437 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 438 | fi |
| 439 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | d9eb284 | 2016-08-12 16:11:24 -0700 | [diff] [blame] | 440 | run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 441 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 442 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 443 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 444 | if [ "$trace_stream" = "true" ]; then |
| 445 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 446 | # the ability to analyze the file and just write to /dev/null. |
| 447 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 448 | # Enable streaming mode. |
| 449 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 450 | else |
| 451 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 452 | fi |
| 453 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 454 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 455 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 456 | fi |
| 457 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 458 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 459 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 460 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 461 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 462 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 463 | if [ "x${suffix64}" = "x64" ]; then |
| 464 | target_arch_name=${grep64bit} |
| 465 | else |
| 466 | target_arch_name=${grep32bit} |
| 467 | fi |
| 468 | } |
| 469 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 470 | function guess_host_arch_name() { |
| 471 | if [ "x${suffix64}" = "x64" ]; then |
| 472 | host_arch_name="x86_64" |
| 473 | else |
| 474 | host_arch_name="x86" |
| 475 | fi |
| 476 | } |
| 477 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 478 | if [ "$target_mode" = "no" ]; then |
| 479 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 480 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 481 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 482 | exit 1; |
| 483 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 484 | fi |
| 485 | fi |
| 486 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 487 | if [ "$have_patchoat" = "no" ]; then |
| 488 | run_args="${run_args} --no-patchoat" |
| 489 | fi |
| 490 | |
| 491 | if [ "$have_dex2oat" = "no" ]; then |
| 492 | run_args="${run_args} --no-dex2oat" |
| 493 | fi |
| 494 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 495 | if [ ! "$runtime" = "jvm" ]; then |
| 496 | run_args="${run_args} --lib $lib" |
| 497 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 498 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 499 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 500 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 501 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 502 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 503 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 504 | else |
| 505 | true # defaults to using target BOOTCLASSPATH |
| 506 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 507 | elif [ "$runtime" = "art" ]; then |
| 508 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 509 | guess_host_arch_name |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 510 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art" |
Colin Cross | afd3c9e | 2016-09-16 13:47:21 -0700 | [diff] [blame] | 511 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 512 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 513 | guess_target_arch_name |
Nicolas Geoffray | f13a365 | 2016-09-22 22:55:58 +0100 | [diff] [blame] | 514 | run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}:${android_root}/lib${suffix64}" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 515 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 516 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 517 | if [ "$relocate" = "yes" ]; then |
| 518 | run_args="${run_args} --relocate" |
| 519 | else |
| 520 | run_args="${run_args} --no-relocate" |
| 521 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 522 | elif [ "$runtime" = "jvm" ]; then |
| 523 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Alex Light | fba89fe | 2017-01-12 16:11:02 -0800 | [diff] [blame] | 524 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 525 | fi |
| 526 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 527 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 528 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 529 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 530 | exit 1 |
| 531 | fi |
| 532 | if [ "$target_mode" = "no" ]; then |
| 533 | framework="${ANDROID_HOST_OUT}/framework" |
| 534 | bpath_suffix="-hostdex" |
| 535 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 536 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 537 | bpath_suffix="" |
| 538 | fi |
| 539 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 540 | # fail since these jar files will be stripped. |
| 541 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
Narayan Kamath | d50687e | 2015-11-17 12:37:27 +0000 | [diff] [blame] | 542 | bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 543 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 544 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 545 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 546 | # Pass down the bootclasspath |
| 547 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 548 | run_args="${run_args} --no-image" |
| 549 | fi |
| 550 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 551 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 552 | err_echo "--dev and --update are mutually exclusive" |
| 553 | usage="yes" |
| 554 | fi |
| 555 | |
| 556 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 557 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 558 | usage="yes" |
| 559 | fi |
| 560 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 561 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 562 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 563 | usage="yes" |
| 564 | fi |
| 565 | |
| 566 | if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then |
| 567 | err_echo "--bisection-search and --no-dex2oat are mutually exclusive" |
| 568 | usage="yes" |
| 569 | fi |
| 570 | |
| 571 | if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then |
| 572 | err_echo "--bisection-search and --no-patchoat are mutually exclusive" |
| 573 | usage="yes" |
| 574 | fi |
| 575 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 576 | if [ "$usage" = "no" ]; then |
| 577 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 578 | test_dir=`basename "$oldwd"` |
| 579 | else |
| 580 | test_dir="$1" |
| 581 | fi |
| 582 | |
| 583 | if [ '!' -d "$test_dir" ]; then |
| 584 | td2=`echo ${test_dir}-*` |
| 585 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 586 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 587 | usage="yes" |
| 588 | fi |
| 589 | test_dir="$td2" |
| 590 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 591 | # Shift to get rid of the test name argument. The rest of the arguments |
| 592 | # will get passed to the test run. |
| 593 | shift |
| 594 | fi |
| 595 | |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 596 | # For building with javac and dx always use Java 7. The dx compiler |
| 597 | # only support byte codes from Java 7 or earlier (class file major |
| 598 | # version 51 or lower). |
| 599 | if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then |
| 600 | export JAVAC="${JAVAC} -source 1.7 -target 1.7" |
| 601 | fi |
| 602 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 603 | if [ "$usage" = "yes" ]; then |
| 604 | prog=`basename $prog` |
| 605 | ( |
| 606 | echo "usage:" |
| 607 | echo " $prog --help Print this message." |
| 608 | echo " $prog [options] [test-name] Run test normally." |
| 609 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 610 | "(dumps to stdout)." |
| 611 | echo " $prog --update [options] [test-name] Update mode" \ |
| 612 | "(replaces expected.txt)." |
| 613 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 614 | "current directory." |
| 615 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 616 | echo " -O Run non-debug rather than debug build (off by default)." |
| 617 | echo " -Xcompiler-option Pass an option to the compiler." |
| 618 | echo " --runtime-option Pass an option to the runtime." |
| 619 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 620 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 621 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 622 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 623 | echo " --build-only Build test files only (off by default)." |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 624 | echo " --build-with-javac-dx Build test files with javac and dx (off by default)." |
| 625 | echo " --build-with-jack Build test files with jack and jill (on by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 626 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 627 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 628 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 629 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 630 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 631 | echo " Verification is enabled if neither --no-verify" |
| 632 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 633 | echo " --no-optimize Turn off optimization (on by default)." |
| 634 | echo " --no-precise Turn off precise GC (on by default)." |
| 635 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 636 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 637 | echo " other runtime options are ignored." |
| 638 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 639 | echo " --no-patchoat Run as though patchoat was failing." |
| 640 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 641 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 642 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 643 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 644 | echo " --relocate Force the use of relocating in the test, making" |
| 645 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 646 | echo " address before running." |
| 647 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 648 | echo " --image Run the test using a precompiled boot image. (default)" |
| 649 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 650 | echo " --host Use the host-mode virtual machine." |
| 651 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 652 | echo " --dalvik Use Dalvik (off by default)." |
| 653 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 654 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 655 | echo " to find the java compiler and runtime" |
| 656 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 657 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 658 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 659 | echo " --64 Run the test in 64-bit mode" |
| 660 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 661 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 662 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 663 | echo " --gcstress Run with gc stress testing" |
| 664 | echo " --gcverify Run with gc verification" |
| 665 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 666 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 667 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 668 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 669 | echo " --instruction-set-features [string]" |
| 670 | echo " Set instruction-set-features for compilation." |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 671 | echo " --npic-image Use an image compiled with non-position independent code " |
| 672 | echo " for the boot class path." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 673 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 674 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 675 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 676 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 677 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 678 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 679 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 680 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 681 | exit 1 |
| 682 | fi |
| 683 | |
| 684 | cd "$test_dir" |
| 685 | test_dir=`pwd` |
| 686 | |
| 687 | td_info="${test_dir}/${info}" |
| 688 | td_expected="${test_dir}/${expected}" |
| 689 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 690 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 691 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 692 | exit 1 |
| 693 | fi |
| 694 | |
| 695 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 696 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 697 | exit 1 |
| 698 | fi |
| 699 | |
| 700 | # copy the test to a temp dir and run it |
| 701 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 702 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 703 | |
| 704 | rm -rf "$tmp_dir" |
| 705 | cp -Rp "$test_dir" "$tmp_dir" |
| 706 | cd "$tmp_dir" |
| 707 | |
| 708 | if [ '!' -r "$build" ]; then |
| 709 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 710 | else |
| 711 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 712 | fi |
| 713 | |
| 714 | if [ '!' -r "$run" ]; then |
| 715 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 716 | else |
| 717 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 718 | fi |
| 719 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 720 | if [ '!' -r "$check_cmd" ]; then |
| 721 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 722 | else |
| 723 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 724 | fi |
| 725 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 726 | chmod 755 "$build" |
| 727 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 728 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 729 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 730 | export TEST_NAME=`basename ${test_dir}` |
| 731 | |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 732 | # arch_supports_read_barrier ARCH |
| 733 | # ------------------------------- |
| 734 | # Return whether the Optimizing compiler has read barrier support for ARCH. |
| 735 | function arch_supports_read_barrier() { |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 736 | # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 737 | # moment. |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 738 | [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ] |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 739 | } |
| 740 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 741 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 742 | # Checker when compiled with Optimizing on host. |
| 743 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 744 | if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 745 | # Optimizing has read barrier support for certain architectures |
| 746 | # only. On other architectures, compiling is disabled when read |
| 747 | # barriers are enabled, meaning that we do not produce a CFG file |
| 748 | # as a side-effect of compilation, thus the Checker assertions |
| 749 | # cannot be checked. Disable Checker for those cases. |
| 750 | # |
| 751 | # TODO: Enable Checker when read barrier support is added to more |
| 752 | # architectures (b/12687968). |
Hiroshi Yamauchi | fd3161a | 2017-01-18 14:47:25 -0800 | [diff] [blame] | 753 | if [ "x$ART_USE_READ_BARRIER" != xfalse ] \ |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 754 | && (([ "x$host_mode" = "xyes" ] \ |
| 755 | && ! arch_supports_read_barrier "$host_arch_name") \ |
| 756 | || ([ "x$target_mode" = "xyes" ] \ |
| 757 | && ! arch_supports_read_barrier "$target_arch_name")); then |
| 758 | run_checker="no" |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 759 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 760 | # patchoat are available. Disable Checker otherwise (b/22552692). |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 761 | elif [ "$prebuild_mode" = "yes" ] \ |
| 762 | || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 763 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 764 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 765 | if [ "$target_mode" = "no" ]; then |
| 766 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 767 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 768 | else |
| 769 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 770 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 771 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 772 | |
| 773 | if [ "$debuggable" = "yes" ]; then |
| 774 | checker_args="$checker_args --debuggable" |
| 775 | fi |
| 776 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 777 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 778 | -Xcompiler-option -j1" |
| 779 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 780 | fi |
| 781 | fi |
| 782 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 783 | run_args="${run_args} --testlib ${testlib}" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 784 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 785 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 786 | build_file_size_limit=2048 |
| 787 | run_file_size_limit=2048 |
Alex Light | 4694e82 | 2016-01-22 10:09:40 -0800 | [diff] [blame] | 788 | |
| 789 | # Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with |
| 790 | # large amounts of expected output or large generated files. |
| 791 | if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 792 | build_file_size_limit=5120 |
| 793 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 794 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 795 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 796 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 797 | # run checker on it. This file can be big. |
Nicolas Geoffray | 4151eff | 2016-11-06 14:24:08 +0000 | [diff] [blame] | 798 | build_file_size_limit=32768 |
| 799 | run_file_size_limit=32768 |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 800 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 801 | if [ ${USE_JACK} = "false" ]; then |
| 802 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 803 | if ! ulimit -S "$build_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 804 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 805 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 806 | fi |
| 807 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 808 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 809 | good_build="yes" |
| 810 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 811 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 812 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 813 | build_exit="$?" |
| 814 | echo "build exit status: $build_exit" 1>&2 |
| 815 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 816 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 817 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 818 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 819 | echo "${test_dir}: running..." 1>&2 |
| 820 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 821 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 822 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 823 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 824 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 825 | if [ "$target_mode" = "yes" ]; then |
| 826 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 827 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 828 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 829 | checker_exit="$?" |
| 830 | if [ "$checker_exit" = "0" ]; then |
| 831 | good="yes" |
| 832 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 833 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 834 | else |
| 835 | good="yes" |
| 836 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 837 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 838 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 839 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 840 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 841 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 842 | build_exit="$?" |
| 843 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 844 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 845 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 846 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 847 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 848 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 849 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 850 | if [ "$target_mode" = "yes" ]; then |
| 851 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 852 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 853 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 854 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 855 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 856 | good="yes" |
| 857 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 858 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 859 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 860 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 861 | elif [ "$build_only" = "yes" ]; then |
| 862 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 863 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 864 | build_exit="$?" |
| 865 | if [ "$build_exit" '!=' '0' ]; then |
| 866 | cp "$build_output" "$output" |
| 867 | echo "build exit status: $build_exit" >>"$output" |
| 868 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 869 | if [ "$?" '!=' "0" ]; then |
| 870 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 871 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 872 | fi |
| 873 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 874 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 875 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 876 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 877 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 878 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 879 | build_exit="$?" |
| 880 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 881 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 882 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 883 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 884 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 885 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 886 | run_exit="$?" |
| 887 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 888 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 889 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 890 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 891 | if [ "$target_mode" = "yes" ]; then |
| 892 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 893 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 894 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 895 | checker_exit="$?" |
| 896 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 897 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 898 | good_run="no" |
| 899 | else |
| 900 | good_run="yes" |
| 901 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 902 | else |
| 903 | good_run="yes" |
| 904 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 905 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 906 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 907 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 908 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 909 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 910 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 911 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 912 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 913 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 914 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 915 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 916 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 917 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 918 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 919 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 920 | # output == expected |
| 921 | good="yes" |
| 922 | echo "${test_dir}: succeeded!" 1>&2 |
| 923 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 924 | fi |
| 925 | fi |
| 926 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 927 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 928 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 929 | echo "${test_dir}: FAILED!" |
| 930 | echo ' ' |
| 931 | echo '#################### info' |
| 932 | cat "${td_info}" | sed 's/^/# /g' |
| 933 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 934 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 935 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 936 | if [ "$strace" = "yes" ]; then |
| 937 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 938 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 939 | echo '####################' |
| 940 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 941 | echo ' ' |
| 942 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 943 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 944 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 945 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 946 | # Attempt bisection only if the test failed. |
| 947 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 948 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 949 | if [ "$run_checker" == "yes" ]; then |
| 950 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 951 | else |
| 952 | # Increase file size limit, bisection search can generate large logfiles. |
| 953 | if ! ulimit -S unlimited; then |
| 954 | err_echo "ulimit file size setting failed" |
| 955 | fi |
| 956 | echo "${test_dir}: bisecting..." 1>&2 |
| 957 | cwd=`pwd` |
| 958 | maybe_device_mode="" |
| 959 | raw_cmd="" |
| 960 | if [ "$target_mode" = "yes" ]; then |
| 961 | # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option |
| 962 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 963 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 964 | # for bisection search to correctly retrieve logs from device. |
| 965 | "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
| 966 | adb shell chmod u+x "$DEX_LOCATION/cmdline.sh" |
| 967 | maybe_device_mode="--device" |
| 968 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 969 | else |
| 970 | raw_cmd="$cwd/${run} --external-log-tags $run_args $@" |
| 971 | fi |
| 972 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 973 | $maybe_device_mode \ |
| 974 | --raw-cmd="$raw_cmd" \ |
| 975 | --check-script="$cwd/check" \ |
| 976 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 977 | --logfile="$cwd/bisection_log.txt" \ |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 978 | --timeout=300 |
| 979 | fi |
| 980 | fi |
| 981 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 982 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 983 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 984 | cd "$oldwd" |
| 985 | rm -rf "$tmp_dir" |
| 986 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 987 | adb shell rm -rf $DEX_LOCATION |
| 988 | fi |
| 989 | if [ "$good" = "yes" ]; then |
| 990 | exit 0 |
| 991 | fi |
| 992 | fi |
| 993 | |
| 994 | |
| 995 | ( |
| 996 | if [ "$always_clean" = "yes" ]; then |
| 997 | echo "${TEST_NAME} files deleted from host " |
| 998 | if [ "$target_mode" == "yes" ]; then |
| 999 | echo "and from target" |
| 1000 | fi |
| 1001 | else |
| 1002 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 1003 | if [ "$target_mode" == "yes" ]; then |
| 1004 | echo "and in ${DEX_LOCATION} on target" |
| 1005 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 1006 | fi |
| 1007 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1008 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1009 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 1010 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 1011 | exit 0 |
| 1012 | else |
| 1013 | exit 1 |
| 1014 | fi |